@echo off
REM ---------------------------------------------------------------------------
REM engine.bat:
REM 	MASTAvP[VGW̊Jn^~Ȃǂsob`t@C
REM
REM	Copyright (c) 2001,2002 PCEW[EeB[ All Rights Reserved.
REM ---------------------------------------------------------------------------
setlocal
set MYNAME=%0
set MYARGS=%*
REM ---------------------------------------------------------------------------
REM R}h̏
REM ---------------------------------------------------------------------------
set _CMD=%1
if "%_CMD%" == "start"           goto startEngine
if "%_CMD%" == "stop"            goto stopEngine
if "%_CMD%" == "restart"         goto restartEngine
if "%_CMD%" == "run"             goto runEngine
if "%_CMD%" == "install"         goto installEngine
if "%_CMD%" == "uninstall"       goto uninstallEngine
if "%_CMD%" == "start_service"   goto startService
if "%_CMD%" == "stop_service"    goto stopService
if "%_CMD%" == "restart_service" goto restartService
if "%_CMD%" == "env"             goto showEnv
REM ---------------------------------------------------------------------------
REM gp@
REM ---------------------------------------------------------------------------
:doUsage
  echo Usage: %0 [ R}h ]
  echo R}hF
  echo    start           - AvP[VGW̊Jn (ʃEChE)
  echo    stop            - AvP[VGW̒~
  echo    restart         - AvP[VGWrestart (ʃEChE)
  echo.
  echo    run             - AvP[VGW̎s (݂̃EChE) fobOp
  echo.
  echo    install         - T[rXւ̃CXg[
  echo    uninstall       - T[rX̃ACXg[ 
  echo    start_service   - T[rX̊Jn
  echo    stop_service    - T[rX̒~
  echo    restart_service - T[rXrestart
  echo.
  echo    env           - ϐl̕\
  echo.
  pause
  echo.
  echo ȉ̊ϐݒ肷邱Ƃ\łB
  echo    JAVA_HOME   - JDK ̃z[tH_
  echo    I3_HOME     - MAST̃z[tH_
  echo    MAGICK_HOME - ImageMagick ̃z[tH_
  echo    ENGINE_NAME - AvP[VGW
  echo    HOSTNAME    - MASTT[õzXg
  echo    CONFIG_DIR  - AvP[VGW̃RtBOtH_
  echo    CONFIG_FILE - AvP[VGW̃RtBOt@C
goto _end

REM ---------------------------------------------------------------------------
REM AvP[VGW̊Jn
REM ---------------------------------------------------------------------------
:startEngine
  call :setUp
  start java %OPTS% -classpath %CP% %START% %START_PARAMS%
goto _end

REM ---------------------------------------------------------------------------
REM AvP[VGW̒~
REM ---------------------------------------------------------------------------
:stopEngine
  call :setUp
  echo not supported yet
goto _end

REM ---------------------------------------------------------------------------
REM AvP[VGWrestart
REM ---------------------------------------------------------------------------
:restartEngine
  call :stopEngine
  call :startEngine
goto _end

REM ---------------------------------------------------------------------------
REM AvP[VGW̎s
REM ---------------------------------------------------------------------------
:runEngine
  call :setUp
  java %OPTS% -classpath %CP% %START% %START_PARAMS%
goto _end

REM ---------------------------------------------------------------------------
REM T[rXւ̃CXg[
REM ---------------------------------------------------------------------------
:installEngine
  call :setUp
  i3engine -install %INSTALL% %LOGON% ^
           -start %START% -params %START_PARAMS% ^
           -stop %STOP% -method %STOP_METHOD% ^
           -current %CURRENT% ^
           -path "%PATH%"
  echo.
  call :startService
goto _end

REM ---------------------------------------------------------------------------
REM T[rX̃ACXg[
REM ---------------------------------------------------------------------------
:uninstallEngine
  call :setUp
  net start | find %ENGINE_NAME% > NUL
  if not ERRORLEVEL 1 call :stopService 2> NUL
  i3engine -uninstall %ENGINE_NAME% | find "successfully"
goto _end

REM ---------------------------------------------------------------------------
REM T[rX̊Jn
REM ---------------------------------------------------------------------------
:startService
  call :setUp
  net start %ENGINE_NAME%
goto _end

REM ---------------------------------------------------------------------------
REM T[rX̒~
REM ---------------------------------------------------------------------------
:stopService
  call :setUp
  net stop %ENGINE_NAME%
goto _end

REM ---------------------------------------------------------------------------
REM T[rXrestart
REM ---------------------------------------------------------------------------
:restartService
  call :stopService
  call :startService
goto _end

REM ---------------------------------------------------------------------------
REM ϐ̐ݒ
REM ---------------------------------------------------------------------------
REM ȉ̕ϐݒ肵܂B
REM
REM    I3_HOME      - MAST home
REM    JAVA_HOME    - JDK home
REM    OPTS         - Java VM options
REM    CP           - Java classpath
REM    START        - start class
REM    START_PARAMS - start params
REM    STOP         - stop class
REM    STOP_METHOD  - stop method
REM ---------------------------------------------------------------------------
:setUp
  set BINDIR=%~dp0
  call "%BINDIR%\i3setenv.bat"
  rem i3setenv sets following variables:
  rem JAVA_HOME, JAVA_VM, ANT_HOME, I3_HOME, TOMCAT_HOME

  if not defined ENGINE_NAME set ENGINE_NAME="MAST Application Engine"
  if not defined MAGICK_HOME set MAGICK_HOME=%I3_HOME%\ImageMagick-win2k
  if not defined HOSTNAME set HOSTNAME=localhost
  rem for /f %%H in ('hostname') do set HOSTNAME=%%H
  if not defined CONFIG_DIR  set CONFIG_DIR=%I3_HOME%\conf\engine
  if not exist %CONFIG_DIR%  set CONFIG_DIR=%I3_HOME%\src\etc
  if not defined CONFIG_FILE set CONFIG_FILE=netlab.xml

  set LOCALCLASSPATH=%CLASSPATH%
  for %%i in ("%I3_HOME%\lib\*.jar") do call "%I3_HOME%\bin\lcp.bat" "%%i"
  set CP=.
  set CP=%CP%;%LOCALCLASSPATH%
  set CP=%CP%;%CONFIG_DIR%
  set CP=%CP%;%I3_HOME%
  set OPTS=
  set OPTS=%OPTS% -Djava.class.path=%CP%
  set OPTS=%OPTS% -Djava.rmi.server.hostname=%HOSTNAME%
  set INSTALL= %ENGINE_NAME% %JAVA_VM% %OPTS%
  set START= jp.co.kgt.i3.task.application.ApplicationEngine
  set START_PARAMS= %CONFIG_DIR%\%CONFIG_FILE%
  set STOP= jp.co.kgt.i3.task.application.ApplicationEngine
  set STOP_METHOD= exit
  set CURRENT= %I3_HOME%
  rem set LOGON=-account mast -pass mast

  set PATH=%MAGICK_HOME%;%PATH%
  set PATH=%I3_HOME%\bin;%PATH%

goto _end
REM ---------------------------------------------------------------------------
REM ϐ̐ݒl̕\
REM ---------------------------------------------------------------------------
:showEnv
  call :setUp
  echo    JAVA_HOME   - %JAVA_HOME%
  echo    JAVA_VM     - %JAVA_VM%
  echo    I3_HOME     - %I3_HOME%
  echo    MAGICK_HOME - %MAGICK_HOME%
  echo    ENGINE_NAME - %ENGINE_NAME%
  echo    HOSTNAME    - %HOSTNAME%
  echo    CONFIG_DIR  - %CONFIG_DIR%
  echo    CONFIG_FILE - %CONFIG_FILE% (under %CONFIG_DIR%)
goto _end

REM ---------------------------------------------------------------------------
REM I
REM ---------------------------------------------------------------------------
:_end
endlocal
