
package jp.ac.chiba_u.astro.ui;

import jp.co.kgt.i3.ui.RunData;
import jp.co.kgt.i3.auth.User;
import jp.co.kgt.i3.auth.I3User;
import jp.co.kgt.i3.exception.*;

import org.apache.log4j.Category;

/**
 * l`rsVXeƂ̃[UF؏sNX
 * @author KGT Inc.
 * @version GVCR1.0
 * @since 2001.12 
 */
public class UserManager {
   static Category log = Category.getInstance(UserManager.class.getName());
   private RunData data = null;
   private User    user = null;

   /**
    * GVCRUserManager̃RXgN^
    * @param data : MAST̃ZbVf[^IuWFNg 
    */
   public UserManager(RunData data) {
      this.data = data;
   }

   /**
    * [U`FbNɂZbV̗L`FbNB
    * ݂͗pĂȂB
    * @return [UIuWFNg 
    */
   public User checkUser() {
      user = data.getUser();
      if (user == null) {
         // session؂Ă܂B
	 log.error("session؂Ă܂B");
      }

      return user;
   }

   /**
    * [UOC̔F؏
    * @return [UIuWFNg
    * @param spm : [U񂪓VXep[^}bv 
    */
   public User loginUser(String account, String password) {
      try {
         user = I3User.getUser(account, password);
	 if (user != null) {
	    data.setUser(user); 
	 } else {
            // F؂Ɏs܂B 
	    log.error("F؂Ɏs܂B");
	 }
      } catch (NoSuchUserException e) {
         // o^[Uł͂܂B 
	 log.error("o^[Uł͂܂B");
      } catch (InvalidPasswordException e) {
         // pX[hĂ܂B 
	 log.error("pX[hĂ܂B");
      } catch (I3Exception e) {
         // Ǘ҂ɑkĂB 
	 log.error("Ǘ҂ɑkĂB");
      }

      return user;
   }
}
