/*
====================================================================
=
=
=
=
=
====================================================================
*/

package jp.ac.chiba_u.astro.ui;

import org.apache.velocity.VelocityContext;
import org.apache.velocity.Template;
import org.apache.velocity.app.Velocity;

import java.io.StringWriter;
import java.lang.Exception;
import java.util.Hashtable;
import java.util.Enumeration;

/**
 *
 * @author KGT Inc.
 * @version 1.0
 * @since 2002.2
*/
public class VTemplateMapper {
   /** RXgN^ */
   public VTemplateMapper() {
   }
   /** }bsOƂ̎s */
   public String doMapping(String filename, Hashtable ht) {
      StringWriter writer = new StringWriter();
      try {
         Velocity.init();
         VelocityContext context = new VelocityContext();

         Enumeration e = null;
         for (e = ht.keys(); e.hasMoreElements();) {
            String keyname  = (String)e.nextElement();
            String keyvalue = (String)ht.get(keyname);
            context.put(keyname, keyvalue);
	 }

         Template templates = null;
         templates = Velocity.getTemplate(filename);

         if (templates == null) {
	    System.out.println("templates is null");
	    return null;
	 }
         templates.merge(context, writer);
      
         writer.flush();
         writer.close();

      } catch(Exception e) {
        System.out.println(e);
      }

      return writer.toString();
   }
   /*
   public static void main(String[] args){
      Hashtable ht = new Hashtable();

      ht.put(args[1], args[2]);

      VTemplateMapper vtm = new VTemplateMapper(); 
      String str = vtm.doMapping(args[0], ht);

      System.out.println(str);
   }
   */
}
