/*
====================================================================
= 
=
=
=
=
====================================================================
*/

package jp.ac.chiba_u.astro.ui.screens;

import jp.ac.chiba_u.astro.etc.OutputPageParam;
import jp.ac.chiba_u.astro.ui.SessionParamIO;
import jp.ac.chiba_u.astro.xml.VizConfigParser;

import jp.co.kgt.i3.ui.RunData;
import jp.co.kgt.i3.ui.VelocityScreen;

import org.apache.velocity.VelocityContext;
import org.apache.log4j.Category;

import java.util.Vector;
import java.util.Hashtable;
import java.util.HashMap;
import java.util.Enumeration;

/**
 * 
 * 
 */
public class Viz302 extends VelocityScreen {
    static Category log = Category.getInstance(Viz302.class.getName());
    RunData data                  = null;
    VelocityContext context       = null;
    HashMap hm                    = null;
    String select_viz_name        = null;
    String job_no                 = null;
    Hashtable viz_list            = null;

    protected void doBuildTemplate(RunData data, VelocityContext context) {
       this.data    = data;
       this.context = context;

       getSessionParam();
       if (getPageParam()) {
          putPageParam();
       } else {
         redirect("error", data); 
       }
       setSessionParam();
    }

    /** åѥ᡼μ */
    protected void getSessionParam() {
       SessionParamIO spio = new SessionParamIO(data);
       hm = spio.getSessionParam("system.param");
       this.viz_list = (Hashtable)hm.get("viz.list");
    }

    /** åѥ᡼ */
    protected void setSessionParam() {
       SessionParamIO spio = new SessionParamIO(data);
       hm.put("avs.job.status", new Integer(0));
       spio.setSessionParam("system.param", hm);
    }
   
    /** Viz301page input */
    protected boolean getPageParam() {
       job_no = data.getParameter("job_no");
       if (job_no.equals("") || job_no == null)
          return false;
       hm.put("cmd.jobid", new Integer(job_no)); 

       select_viz_name = data.getParameter("viz_select");
       if (select_viz_name.equals("") || select_viz_name == null)
          return false;
       hm.put("select.viz.name", select_viz_name); 

       return true;
    }

    /** Viz302ڡ */
    protected void putPageParam() {
       select_viz_name = (String)hm.get("select.viz.name");
       Hashtable pt = (Hashtable)viz_list.get(select_viz_name);
       Vector param_list = (Vector)viz_list.get(select_viz_name+".list");

       OutputPageParam viz302 = new OutputPageParam();
       viz302.set("select.viz.name", select_viz_name);
       viz302.set("param.list", param_list);
       viz302.set("value.list", pt);
       context.put("viz302", viz302);
    }
}
