/*
====================================================================
=
=
=
=
=
====================================================================
*/

package jp.ac.chiba_u.astro.xml;

import jp.ac.chiba_u.astro.xml.VizConfigConv;

import java.io.*;
import java.util.*;
import org.apache.xerces.parsers.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;

/**
 * 
 * @version 1.0
 * @author  KGT Inc.
 * @since   2002.4 
 */
public class VizConfigParser {
   Hashtable ht = null;

   /**
    * RXgN^
    * @document ͂ɂ̓p[XsXMLt@Cw肷B 
    */
   public VizConfigParser(String file) {
      SAX2Handler handler = new SAX2Handler();
      XMLReader parser = new SAXParser();

      try {
         parser.setContentHandler(handler);
         parser.parse(file);

         Vector contents = handler.getContents();
         VizConfigConv vcc = new VizConfigConv(contents); 
         ht = vcc.getConfig();
      } catch(SAXException saxe) {
         System.out.println("SAXException:"+saxe);
      } catch(IOException ioe) {
         System.out.println("IOException:"+ioe);
      }
   }

   /**
    * p[Xs̃nbVe[u擾B 
    */
   public Hashtable getConfig() {
      return ht;
   }
}
