
enttl=(sqrt(!pi)*wexp)^3/(gm-1)
scl=fltarr(nx)
scl(1:*)=1.12*enttl^0.2*t(1:*)^0.4

d_s=fltarr(nx)
d_s(1:*)=0.4*scl(1:*)/t(1:*)

x_s=fltarr(ix,nx)
for n=1,nx-1 do x_s(*,n)=x/scl(n)

pr_s=pr
ro_s=ro
vx_s=vx

for n=1,nx-1 do pr_s(*,n)=pr(*,n)/2*(gm+1)/d_s(n)^2
for n=1,nx-1 do ro_s(*,n)=ro(*,n)/(gm+1)*(gm-1)
for n=1,nx-1 do vx_s(*,n)=vx(*,n)/2*(gm+1)/d_s(n)

nt0=n_elements(t)
window,xsize=480,ysize=320
xinteranimate,set=[480,320,nt0]

for n=0,nt0-1 do begin

!p.multi=[0,3,1]
!x.style=1
!p.charsize=1.5

!x.range=[0,0.4]
plot,x,pr(*,n),title='Pr',yrange=[1.e-4,1],linest=0,/yl
stime='!8t!3 ='+string(format='(f5.2)',t(n))
xyouts,0.2,0.5,stime,/data,size=1.0

plot,x,ro(*,n),title='De',yrange=[0,5],linest=0

plot,x,vx(*,n),yr=[-0.05,0.1],title='vx',linest=0

!p.multi=0
!x.style=0
!x.range=0
!p.charsize=1.

xinteranimate,frame=n,window=0
endfor

xinteranimate

delvar,nt0,stime

end
