c======================================================================|
      subroutine model(idf,ro,pr,vx,gm,sc,scm,margin,x,ix)
c======================================================================|
      implicit real*8 (a-h,o-z)
c----------------------------------------------------------------------|
      dimension x(ix)
      dimension dxm(ix)

      dimension sc(ix),scm(ix)

      dimension ro(ix),pr(ix),vx(ix)

c----------------------------------------------------------------------|
c   parameters
c----------------------------------------------------------------------|
      gm=5./3.
c-----------------------------------------------------------------------
c     grid
c-----------------------------------------------------------------------
      dx0=1./real(ix-margin*2+1)

      do i=1,ix
         dxm(i)=dx0
      enddo

      izero=margin+1
      izero=1
      x(izero)=0.500001d0*dx0

        do i=izero+1,ix
           x(i) = x(i-1)+dxm(i-1)
        enddo
        do i=izero-1,1,-1
           x(i) = x(i+1)-dxm(i)
        enddo
c----------------------------------------------------------------------|
c       cross section of flux tube
c----------------------------------------------------------------------|

      do i=1,ix
        sc(i)=x(i)**2
        scm(i)=(x(i)+0.5*dxm(i))**2
      enddo


c-----------------------------------------------------------------------|
c   initial temperature, density, pressure distributions
c-----------------------------------------------------------------------|

      prism=1.e-8
      wexp=0.02

      do i=1,ix
         ro(i)  = 1.
         vx(i) = 0.0
         pr(i)  = prism+(1.-prism)*exp(-(x(i)/wexp)**2)
      enddo
      
c                                                     netcdf - start >>>
      call ncputos(idf,'wexp',wexp)
      call ncputos(idf,'prism',prism)
c                                                     netcdf - end   <<<

      return
      end
