c======================================================================|
      subroutine model(idf,ro,pr,vx,gm,margin,x,ix)
c======================================================================|
      implicit real*8 (a-h,o-z)
c----------------------------------------------------------------------|
      dimension x(ix),dxm(ix)
      dimension ro(ix),pr(ix),vx(ix)

c----------------------------------------------------------------------|
c   parameters
c----------------------------------------------------------------------|
      gm=1.4

c----------------------------------------------------------------------|
c   grid
c----------------------------------------------------------------------|
c      dxm,x

      dx0=1./real(ix-margin*2+1)
      do i=1,ix
         dxm(i)=dx0
      enddo
       
      izero=ix/2+1
      x(izero)=0.
      do i=izero+1,ix
         x(i) = x(i-1)+dxm(i-1)
      enddo
      do i=izero-1,1,-1
         x(i) = x(i+1)-dxm(i)
      enddo

c----------------------------------------------------------------------|
c     store initial condition into common area
c----------------------------------------------------------------------|
      ro1=0.125
      pr1=0.1
      vx0=0.
      vx1=0.

      open(unit=1,file='para.txt')
      read(1,100) ro1
      read(1,100) pr1
      read(1,100) vx1
      read(1,100) vx0
 100  FORMAT((G13.6))
      close(unit=1)

      do i=1,ix
         if (i.le.ix/2) then
           ro(i)  = 1.
           pr(i)  = 1.
           vx(i)  = vx0
         else
           ro(i)  = ro1
           pr(i)  = pr1
           vx(i)  = vx1
         endif
      enddo
c----------------------------------------------------------------------|
c     write parameters to file
c----------------------------------------------------------------------|
c                                                     netcdf - start >>>
      call ncputos(idf,'ro1',ro1)
      call ncputos(idf,'pr1',pr1)
      call ncputos(idf,'vx0',vx0)
      call ncputos(idf,'vx1',vx1)
c                                                     netcdf - end   <<<

      
      return
      end
