/*
====================================================================
= 
=
=
=
=
====================================================================
*/

package jp.ac.chiba_u.astro.ui.screens;

import jp.ac.chiba_u.astro.etc.OutputPageParam;
import jp.ac.chiba_u.astro.ui.SessionParamIO;
import jp.ac.chiba_u.astro.xml.CommandConfigParser;

import jp.co.kgt.i3.ui.RunData;
import jp.co.kgt.i3.ui.VelocityScreen;

import org.apache.velocity.VelocityContext;
import org.apache.log4j.Category;

import java.util.Vector;
import java.util.Hashtable;
import java.util.HashMap;

/**
 * 
 * 
 */
public class Viz102 extends VelocityScreen {
    static Category log = Category.getInstance(Viz102.class.getName());
    RunData data               = null;
    VelocityContext context    = null; 
    String select_command_name = null;
    Hashtable command_list     = null;
    HashMap hm                 = null;
    
    protected void doBuildTemplate(RunData data, VelocityContext context) {
       this.data    = data;
       this.context = context;

       getSessionParam();
       getPageParam();
       putPageParam();
       setSessionParam();
    }

    /** ZbVp[^̎擾 */
    protected void getSessionParam() {
       SessionParamIO spio = new SessionParamIO(data);
       hm = spio.getSessionParam("system.param");
       this.command_list = (Hashtable)hm.get("command.list");
    }

    /** ZbVp[^̐ݒ */
    protected void setSessionParam() {
       SessionParamIO spio = new SessionParamIO(data);
       spio.setSessionParam("system.param", hm);
    }

    /** Oy[Wp[^̎擾 */
    protected void getPageParam() {
       select_command_name = data.getParameter("command_select");
       if (select_command_name != null)
          hm.put("select.command.name", select_command_name);
    }

    /** Viz102y[Wo */
    protected void putPageParam() {
       select_command_name = (String)hm.get("select.command.name");
       Hashtable pt = (Hashtable)command_list.get(select_command_name);
       Vector param_list = (Vector)command_list.get(select_command_name+".list");

       OutputPageParam viz102 = new OutputPageParam();
       viz102.set("select.command.name", select_command_name);
       viz102.set("param.list", param_list);
       viz102.set("value.list", pt);
       context.put("viz102", viz102);
    }
}
