/*
====================================================================
= 
=
=
=
=
====================================================================
*/

package jp.ac.chiba_u.astro.ui.screens;

import jp.ac.chiba_u.astro.etc.OutputPageParam;
import jp.ac.chiba_u.astro.ui.SessionParamIO;

import jp.co.kgt.i3.ui.RunData;
import jp.co.kgt.i3.ui.VelocityScreen;
import jp.co.kgt.i3.auth.User;
import jp.co.kgt.i3.task.job.Job;
import jp.co.kgt.i3.task.job.JobManager;
import jp.co.kgt.i3.task.job.JobStatus;

import org.apache.velocity.VelocityContext;
import org.apache.log4j.Category;

import java.util.Vector;
import java.util.Hashtable;
import java.util.HashMap;
import java.util.Enumeration;

/**
 * 
 * 
 */
public class Viz202 extends VelocityScreen {
    static Category log = Category.getInstance(Viz202.class.getName());
    RunData data            = null;
    VelocityContext context = null;
    HashMap hm              = null;
    String job_id           = null;
    String cmdStatus        = null;
    String applname         = null;

    protected void doBuildTemplate(RunData data, VelocityContext context) {
       this.data    = data;
       this.context = context;

       getSessionParam();

       if (getPageParam()) {
          if (getCmdStatus())
             putPageParam();
	  else
	     redirect("error", data);
       } else {
	  redirect("error", data);
       }
    }

    /** ZbVp[^̎擾 */
    protected void getSessionParam() {
       SessionParamIO spio = new SessionParamIO(data);
       this.hm = spio.getSessionParam("system.param");
       this.applname = (String)hm.get("cmd.application.name");
    }

    /** R}hXe[^X̎擾 */
    protected boolean getCmdStatus() {
       boolean state   = true;

       JobManager jm = JobManager.getInstance();
       try {
 	  cmdStatus = (String)jm.getParameter(Integer.parseInt(job_id), applname, "cmdStatus");
       } catch(Exception e) {
          log.error("JOBXe[^X擾ł܂łB");
	  state = false;
	  return state;
       }
       return state;
    }

    /** Oy[Wp[^̎擾 */
    protected boolean getPageParam() {
       job_id = data.getParameter("job_id"); 
       if (job_id.equals("") || job_id == null)
          return false;
        return true;
    }

    /** Viz202y[Wo */
    protected void putPageParam() {
       OutputPageParam viz202 = new OutputPageParam();       
       viz202.set("cmd.jobid", job_id);
       viz202.set("cmd.status", cmdStatus);
       context.put("viz202", viz202);
    }
}
