/*
====================================================================
=
=
=
=
=
====================================================================
*/

package jp.ac.chiba_u.astro.ui.screens;

import jp.ac.chiba_u.astro.etc.OutputPageParam;
import jp.ac.chiba_u.astro.ui.SessionParamIO;
import jp.ac.chiba_u.astro.xml.VizConfigParser;

import jp.co.kgt.i3.ui.RunData;
import jp.co.kgt.i3.ui.VelocityScreen;

import org.apache.velocity.VelocityContext;
import org.apache.log4j.Category;

import java.util.Vector;
import java.util.Hashtable;
import java.util.HashMap;
import java.util.Enumeration;

/**
 * 
 * 
 */
public class Viz301 extends VelocityScreen {
    static Category log = Category.getInstance(Viz301.class.getName());
    RunData data                  = null;
    VelocityContext context       = null; 
    String viz_script_config_file = null;
    Hashtable viz_list            = null;
    HashMap hm                    = null;

    protected void doBuildTemplate(RunData data, VelocityContext context) {
       this.data    = data;
       this.context = context;

       getSessionParam();
       readVizScriptConfig();
       putPageParam();
       setSessionParam();
    }

    /** ZbVp[^̎擾 */
    protected void getSessionParam() {
       SessionParamIO spio = new SessionParamIO(data);
       hm = spio.getSessionParam("system.param");
       this.viz_script_config_file = (String)hm.get("viz.script.config.file");
    }

    /** ZbVp[^̐ݒ */
    protected void setSessionParam() {
       SessionParamIO spio = new SessionParamIO(data);
       hm.put("viz.list", viz_list);
       spio.setSessionParam("system.param", hm);
    }

    /** R}hXg̎擾 */
    protected void readVizScriptConfig() {
       VizConfigParser vcp = new VizConfigParser(viz_script_config_file);
       this.viz_list = vcp.getConfig();
    }

    /** Viz301y[Wo */
    protected void putPageParam() {
       Enumeration e = null;
       Vector vizList = new Vector();

       for (e = viz_list.keys(); e.hasMoreElements();) {
          String keyname = (String)e.nextElement();
	  if (keyname.indexOf(".list") == -1)
	     vizList.add(keyname);
       }

       OutputPageParam viz301 = new OutputPageParam();       
       viz301.set("viz.list", vizList);
       context.put("viz301", viz301);
    }
}
